<script lang="ts">
    import getHumanName from '$utils/getHumanName'
    import type Unit from '$models/Unit'
    import type District from '$models/District'
    import type { Writable } from 'svelte/store'

    export let district: District
    export let unit: Unit
    export let units: Writable<Unit[]>

    let value = 0

    const create = async () => {
        if (value <= 0) return

        const { res } = await district.addUnit(unit.type, value)
        if (null === res) return
        units.update(u => {
            u.forEach((unit, index) => {
                if (unit.type === res.type) u[index] = res
            })

            return u
        })

        value = 0
    }
</script>

<form on:submit|preventDefault={create}>
    <details>
        <summary>{getHumanName(unit.type)}</summary>
        <ul>
            <li>Attack: {unit.attack}</li>
            <li>Defense: {unit.defense}</li>
            <li>Speed: {unit.speed}</li>
        </ul>
    </details>
    <div class="control">
        <label for="{unit.type}-build-amount">Number to build</label>
        <div class="inputs">
            <input id="{unit.type}-build-amount" type="number" min="0" step="1" bind:value />
            {#if value > 0}
                <input type="submit" value="Build" />
            {:else}
                <input type="submit" value="Build" disabled />
            {/if}
        </div>
    </div>
</form>

<style lang="postcss">
    summary {
        @apply font-semibold;
    }

    ul {
        @apply px-4 text-trueGray-500 dark:text-trueGray-400;
    }

    .control {
        @apply flex items-center justify-between w-full;

        label {
            @apply whitespace-nowrap w-full;
        }

        .inputs {
            @apply flex-none flex gap-x-2 max-w-[50%];

            input[type='number'] {
                @apply flex-shrink px-2 py-1 min-w-0 text-trueGray-900;
            }

            input[type='submit'] {
                @apply px-4 py-1 cursor-pointer transition-colors duration-150 ease-out
                bg-fuchsia-200 text-fuchsia-900 hover:bg-fuchsia-100 hover:text-fuchsia-800
                dark:bg-fuchsia-900 dark:text-fuchsia-50 hover:dark:bg-fuchsia-800 hover:dark:text-fuchsia-100;
                clip-path: polygon(calc(100% - 0.1rem) 0, 100% 100%, 0.1rem 100%, 0 0);
            }
        }
    }
</style>
